From 3fd7f56275674a5ce22ef987be7596d1c27195f0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 23 2020 04:02:02 +0000
Subject: [PATCH 40/2232] Test rust calling to c++


---

diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 26c14fe..cfe07ab 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -1,10 +1,14 @@
 #include "tests/ffi/tests.h"
 #include "tests/ffi/lib.rs"
 
+extern "C" void cxx_test_suite_set_correct();
+
 namespace tests {
 
 C::C(size_t n) : n(n) {}
 
+size_t C::get() const { return this->n; }
+
 size_t c_return_primitive() { return 2020; }
 
 Shared c_return_shared() { return Shared{2020}; }
@@ -26,22 +30,53 @@ std::unique_ptr<std::string> c_return_unique_ptr_string() {
   return std::unique_ptr<std::string>(new std::string("2020"));
 }
 
-void c_take_primitive(size_t n) { (void)n; }
+void c_take_primitive(size_t n) {
+  if (n == 2020) {
+    cxx_test_suite_set_correct();
+  }
+}
 
-void c_take_shared(Shared shared) { (void)shared; }
+void c_take_shared(Shared shared) {
+  if (shared.z == 2020) {
+    cxx_test_suite_set_correct();
+  }
+}
 
-void c_take_box(cxxbridge::RustBox<R> r) { (void)r; }
+void c_take_box(cxxbridge::RustBox<R> r) {
+  (void)r;
+  cxx_test_suite_set_correct();
+}
 
-void c_take_unique_ptr(std::unique_ptr<C> c) { (void)c; }
+void c_take_unique_ptr(std::unique_ptr<C> c) {
+  if (c->get() == 2020) {
+    cxx_test_suite_set_correct();
+  }
+}
 
 void c_take_ref_r(const R &r) { (void)r; }
 
-void c_take_ref_c(const C &c) { (void)c; }
+void c_take_ref_c(const C &c) {
+  if (c.get() == 2020) {
+    cxx_test_suite_set_correct();
+  }
+}
 
-void c_take_str(cxxbridge::RustStr s) { (void)s; }
+void c_take_str(cxxbridge::RustStr s) {
+  if (std::string(s) == "2020") {
+    cxx_test_suite_set_correct();
+  }
+}
 
-void c_take_rust_string(cxxbridge::RustString s) { (void)s; }
+void c_take_rust_string(cxxbridge::RustString s) {
+  if (std::string(s) == "2020") {
+    cxx_test_suite_set_correct();
+  }
+}
 
-void c_take_unique_ptr_string(std::unique_ptr<std::string> s) { (void)s; }
+void c_take_unique_ptr_string(std::unique_ptr<std::string> s) {
+  if (*s == "2020") {
+    cxx_test_suite_set_correct();
+  }
+}
 
 } // namespace tests
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 8510946..14e019f 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -11,6 +11,7 @@ struct Shared;
 class C {
 public:
   C(size_t n);
+  size_t get() const;
 
 private:
   size_t n;
diff --git a/tests/test.rs b/tests/test.rs
new file mode 100644
index 0000000..9f595f7
--- /dev/null
+++ b/tests/test.rs
@@ -0,0 +1,55 @@
+use cxx_test_suite::ffi;
+use std::cell::Cell;
+
+thread_local! {
+    static CORRECT: Cell<bool> = Cell::new(false);
+}
+
+#[no_mangle]
+extern "C" fn cxx_test_suite_set_correct() {
+    CORRECT.with(|correct| correct.set(true));
+}
+
+#[test]
+fn test_c_return() {
+    let shared = ffi::Shared { z: 2020 };
+
+    assert_eq!(2020, ffi::c_return_primitive());
+    assert_eq!(2020, ffi::c_return_shared().z);
+    ffi::c_return_unique_ptr();
+    assert_eq!(2020, *ffi::c_return_ref(&shared));
+    assert_eq!("2020", ffi::c_return_str(&shared));
+    assert_eq!("2020", ffi::c_return_rust_string());
+    assert_eq!(
+        "2020",
+        ffi::c_return_unique_ptr_string()
+            .as_ref()
+            .unwrap()
+            .to_str()
+            .unwrap()
+    );
+}
+
+#[test]
+fn test_c_take() {
+    macro_rules! check {
+        ($run:expr) => {{
+            CORRECT.with(|correct| correct.set(false));
+            $run;
+            assert!(CORRECT.with(|correct| correct.get()), stringify!($run));
+        }};
+    }
+
+    let unique_ptr = ffi::c_return_unique_ptr();
+
+    check!(ffi::c_take_primitive(2020));
+    check!(ffi::c_take_shared(ffi::Shared { z: 2020 }));
+    check!(ffi::c_take_box(Box::new(())));
+    check!(ffi::c_take_ref_c(unique_ptr.as_ref().unwrap()));
+    check!(ffi::c_take_unique_ptr(unique_ptr));
+    check!(ffi::c_take_str("2020"));
+    check!(ffi::c_take_rust_string("2020".to_owned()));
+    check!(ffi::c_take_unique_ptr_string(
+        ffi::c_return_unique_ptr_string()
+    ));
+}

